const ACTIVEWEAVE = "http://www.stickis.com/"
const SUGGESTIONS = ACTIVEWEAVE + "ajax/tags.json.jsp"
const nsIResult = Components.interfaces.nsIAutoCompleteResult;

function awTagSearch()
{
  var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                      .createInstance(Components.interfaces.nsIJSXMLHttpRequest);

  this.startSearch = function startSearch(searchString, searchParam, previousResult, listener)
  {
    var tags = searchString.split(',');
    var tag = tags[tags.length - 1].replace(/(?:^\s+|\s+$)/g, '').replace(/\s+/g, ' ');
    if (!tag || tag == '')
      return listener.onSearchResult(self, null, nsIResult.RESULT_IGNORED);

    var qry = "query=" + tag;

    req.open('POST', SUGGESTIONS, true);
    req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    req.onload = doMakeResult;

    var self = this;

    function doMakeResult()
    {
      var list = [];
      var sandbox = Components.utils.Sandbox(ACTIVEWEAVE);
      list = Components.utils.evalInSandbox("list = "+ req.responseText, sandbox);

      var matches = [];

      // convert the data to a plain list of suggestions. why it
      // doesn't simply return a plain list is beyond me.
      if ("suggest" in list)
        list.suggest.t.forEach(function (elem) { elem && elem.n && matches.push(elem.n); });

      var results = new awTagResults(matches, searchString, nsIResult.RESULT_SUCCESS);
      listener.onSearchResult(self, results);
    }

    req.send(encodeURI(qry));

    return null;
  };

  this.stopSearch = function stopSearch()
  {
    req.abort();
  };

  this.QueryInterface = function QueryInterface(aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIAutoCompleteSearch) &&    
        !aIID.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  };
}

function awTagResults(list, search, type)
{
  var data = list || [];

  this.defaultIndex = 0;
  this.errorDescription = undefined;
  this.matchCount = data.length;
  this.searchResult = data.length == 0 ? nsIResult.RESULT_NOMATCH : type;
  this.searchString = search;

  this.getCommentAt = function getCommentAt(idx)
  {
    return "";
  };

  this.getStyleAt = function getStyleAt(idx)
  {
    return "";
  };

  this.getValueAt = function getValueAt(idx)
  {
    return data[idx];
  };

  this.removeValueAt = function removeValueAt(idx)
  {
    data = data.splice(idx, 1);
  };

  this.QueryInterface = function QueryInterface(aIID)
  {
    if (!aIID.equals(Components.interfaces.nsIAutoCompleteResult) &&    
        !aIID.equals(Components.interfaces.nsISupports))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  };
}

// all the rest of this is just the magic incantation for creating a module.
function NSGetModule()
{
  var components = [
    {
      name: "Activeweave Tag Suggestion Search",
      classID: Components.ID("{32f17767-735f-46de-a11d-a16b48324260}"),
      contractID: "@mozilla.org/autocomplete/search;1?name=aw-tag-search",
      factory: makeFactory(awTagSearch)
    },
    {
      name: "Activeweave Tag Suggestion Results",
      classID: Components.ID("{8f430d1e-ee24-4260-a88c-7f534d9887db}"),
      contractID: "@activeweave.com/tagsearch/results;1",
      factory: makeFactory(awTagResults)
    }
  ];

  function makeFactory(obj)
  {
    return {
      createInstance: function createInstance(outer, iid)
      {
        if (outer != null)
          throw Components.results.NS_ERROR_NO_AGGREGATION;

        return (new obj).QueryInterface(iid);
      }
    };
  }

  return {
    registerSelf: function(compMgr, fileSpec, location, type)
    {
      compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

      for each (component in components)
        compMgr.registerFactoryLocation(component.classID,
                                        component.name,
                                        component.contractID,
                                        fileSpec,
                                        location,
                                        type);
    },

    unregisterSelf: function(compMgr, location, type)
    {
      compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

      for each (component in components)
        compMgr.unregisterFactoryLocation(component.classID, location);
    },

    getClassObject: function(compMgr, cid, iid)
    {
      if (!iid.equals(Components.interfaces.nsIFactory))
        throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

      for each (component in components)
        if (cid.equals(component.classID))
          return component.factory;

      throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload: function(compMgr)
    {
      return true;
    }
  }
}
